﻿using System.Collections.Generic;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            KeyPreview = true;

            List<KeyItem> list = new List<KeyItem>();

            list.Add(new KeyItem { Value = "ControlKey", Text = "Ctrl"  });
            list.Add(new KeyItem { Value = "ShiftKey"  , Text = "Shift" });
            list.Add(new KeyItem { Value = "AltKey"    , Text = "Alt"   });

            this.comboBox.DropDownStyle = ComboBoxStyle.DropDownList;
            this.comboBox.ValueMember   = nameof(KeyItem.Value);
            this.comboBox.DisplayMember = nameof(KeyItem.Text );
            this.comboBox.DataSource    = list;
            this.comboBox.SelectedIndex = 0;

            KeyUp                += Form_KeyUp;
            this.textBox.KeyUp   += textBox_KeyUp;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 폼 키 UP 처리하기 - Form_KeyUp(sender, e)

        /// <summary>
        /// 폼 키 UP 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_KeyUp(object sender, KeyEventArgs e)
        {
            string selectedValue = this.comboBox.SelectedValue.ToString();

            if(((e.Control && selectedValue == "ControlKey") || (e.Shift && selectedValue == "ShiftKey") || (e.Alt && selectedValue == "AltKey")) && (e.KeyCode == (Keys)textBox.Tag))
            {
                MessageBox.Show("설정한 단축키가 눌렸습니다!");
            }
        }

        #endregion
        #region 텍스트 박스 키 UP 처리하기 - textBox_KeyUp(sender, e)

        /// <summary>
        /// 텍스트 박스 키 UP 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void textBox_KeyUp(object sender, KeyEventArgs e)
        {
            if(e.KeyValue < 229)
            {
                this.textBox.Text = e.KeyData.ToString();

                this.textBox.Tag = e.KeyData;
            }
            else
            {
                this.textBox.Text = string.Empty;

                this.textBox.Tag = Keys.None;
            }
        }

        #endregion
    }
}